<?php
require_once ('classes/ircclient.php');
require_once ('classes/template.php');
require_once ('config.php');
require_once ('regex.php');

define ('IRC_LOG_COMMUNICATIONS', TRUE);

function do_step_one ( )
{
    global $tpl, $channel_name, $channel_owner_handle,
            $channel_owner_email, $channel_owner_password,
            $irc, $irc_nick, $irc_user, $irc_name, $irc_host,
            $irc_server, $irc_botnick, $dbx, $db_server,
            $db_port, $db_user, $db_pass, $db_database,
            $db_table;
    
    $tpl->set_file ('main', 'templates/aup.html');
    $tpl->set_block ('main', 'ErrorBlock', 'error_used_block');
    $tpl->set_var ( array (
            'txtChannelName',
            'txtOwnerHandle',
            'txtOwnerPassword',
            'txtOwnerEmail'
    ) );
    include ("lang/en.php");
    $tpl->pparse ('out', 'main');
}

function makePass() {
    $makepass="";
    $syllables="er,in,tia,wol,fe,pre,vet,jo,nes,al,len,son,cha,ir,ler,bo,ok,tio,nar,sim,ple,bla,ten,toe,cho,co,lat,spe,ak,er,po,co,lor,pen,cil,li,ght,wh,at,the,he,ck,is,mam,bo,no,fi,ve,any,way,pol,iti,cs,ra,dio,sou,rce,sea,rch,pa,per,com,bo,sp,eak,st,fi,rst,gr,oup,boy,ea,gle,tr,ail,bi,ble,brb,pri,dee,kay,en,be,se";
    $syllable_array=explode(",", $syllables);
    srand((double)microtime()*1000000);
    for ($count=1;$count<=4;$count++) {
        if (rand()%10 == 1) {
            $makepass .= sprintf("%0.0f",(rand()%50)+1);
        } else {
            $makepass .= sprintf("%s",$syllable_array[rand()%62]);
        }
    }
    return($makepass);
}

function do_step_two()
{
	global $my, $tpl, $channel_name, $channel_owner_handle,
		   $channel_owner_email, $channel_owner_password,
		   $irc, $irc_nick, $irc_user, $irc_name, $irc_host,
           $irc_server, $irc_botnick, $dbx, $db_server,
		   $db_port, $db_user, $db_pass, $db_database,
		   $db_table;

	$errors = array();
	$i = 0;
		
	$channel_name = post_clean ($_REQUEST['channel_name']);

        $channel_owner_handle = $my->username;

        $sql = "SELECT email FROM mos_users WHERE id=$my->id";
        $res = db_query($sql);
        if(mysql_num_rows($res) < 1)
        {
           $errors[] = '{errYourIDWasNotFound}';
        }
        else
        {
            $channel_owner_email = mysql_result($res, 0);
        }
			
        $channel_owner_password = makePass();
	if ( !isset($_POST['iagree']) || $_POST['iagree'] <> 'true' )
        {
            $errors[] = '{errAupNotAccepted}';
        }
	if ( !validate_channel ($channel_name, 1, 49) ) {
		$errors[] = '{errInvalidChannelName}';
	}
		
	else if ( channel_registered ($channel_name) ) {
		$errors[] = '{errChannelIsRegisterd}';
	}

	
	if ( count ($errors) > 0 )
	{
		$tpl->set_file ('main', 'templates/aup.html');
		$tpl->set_var ( array (
			'txtChannelName' => $channel_name,
		) );
		$tpl->set_block ('main', 'ErrorBlock', 'error_blk');
	
		for ($i = 0; $i < count ($errors); $i++)
		{
			$tpl->set_var ('error', $errors[$i]);
			$tpl->parse ('error_blk', 'ErrorBlock', true);
		}
		
		include ("lang/en.php");
		$tpl->pparse ('out', 'main');
	}
	
	else 
	{
		
		$irc = new IRCClient ($irc_nick, $irc_user, $irc_name, $irc_host);
		$irc->irc_register_callback ('001', 'irc_on_connect');
		$irc->irc_register_callback ('433', 'irc_on_nicknameinuse');
		$irc->irc_register_callback ('PRIVMSG', 'irc_on_privmsg');
		$irc->irc_register_callback ('NOTICE', 'irc_on_privmsg');
                $irc->irc_register_callback ('timeout', 'irc_on_timeout');
		$irc->irc_connect($irc_server);
                return;

	}
}

/* The purpose of this is.. ??? */
function post_clean ( $key )
{
	return trim ($key);
}

function validate_channel ( $channel, $min=1, $max=200 )
{
	global $_channel;

	    // if ( preg_match ("/^{$_channel}{{$min},{$max}}$/", $channel) ) {

        if ( preg_match ('/^[#][A-Za-z0-9][A-Za-z0-9_.{}-]*$/', $channel) ) {
		return true;
	}
	return false;
}

function channel_registered ( $channel )
{
    // DEBUG: Temp disabling due to
    // lack of x2 on this server
	return false;
    global $chandatpath;

    $cf = fopen($chandatpath, "r");
    if($cf)
    {
        while($chans = fscanf($cf, "%s"))
        {
            list($chan) = $chans;
            if(!strcasecmp($chan,$channel) or !strcasecmp($channel, "#afternet") or
                                              !strcasecmp($channel, "#help") or
                                              !strcasecmp($channel, "#Operations") )
                            $conflict = 1;
        }
    }
    if($conflict)
    {
       return true;
    }

    return false;
}

function db_connect ()
{
	global $dbx;
	global $db_server, $db_port, $db_user, $db_pass, $db_database;

	$dbx = @mysql_connect ("{$db_server}:{$db_port}", $db_user, $db_pass);
	@mysql_select_db ($db_database);
	
	return $dbx;
}

function db_query ( $query )
{
	$dbx = db_connect();
	$res = @mysql_query ($query, $dbx);

	if (!$res) {
		global $tpl;
		$tpl->set_file ('main', 'templates/dberror.html');
		$tpl->set_var ('query', $query);
		$tpl->set_var ('error', @mysql_error());
		$tpl->set_var ('errno', @mysql_errno());
		$tpl->pparse ('out', 'main');
		exit;
	}

	return $res;
}

function irc_on_connect ( $data, $object )
{
    global $tpl, $channel_name, $channel_owner_handle,
            $channel_owner_password, $channel_owner_email,
            $irc, $irc_nick, $irc_user, $irc_name, $irc_host,
            $irc_server, $irc_botnick, $irc_oper, $dbx, $db_server,
	    $db_port, $db_user, $db_pass, $db_database,
	    $db_table;
		   
    /* We connected successfully. Send oper and scriptreg */
    $object->irc_send_msg("$irc_oper");
    $object->irc_send_msg (
    preg_replace('/[\n]/','',  // no hacking me!!
           sprintf ("PRIVMSG %s :SCRIPTREG %s %s %s %s %s",
                    $irc_botnick, $channel_name, $channel_owner_handle,
                    $channel_owner_password, $channel_owner_email, '+nt' )
                   )
                );
    return(TRUE);
}

function irc_on_privmsg ( $data, $object )
{
	global $tpl, $channel_name, $channel_owner_handle,
		   $channel_owner_email, $channel_owner_password,
		   $irc, $irc_nick, $irc_user, $irc_name, $irc_host,
                   $irc_server, $irc_botnick, $dbx, $db_server,
		   $db_port, $db_user, $db_pass, $db_database,
		   $db_table;
		   
	$nick = substr ($data[0], 0, strpos ($data[0], '!'));
	
        $data[3] = str_replace("\002", "", $data[3]);
	if ( (strtoupper($data[2]) == strtoupper($object->irc_nick)) && ($nick == $irc_botnick) ) {
		if ( preg_match ("/Owner\:\ SUCCESS/", $data[3]) ) {
			$object->irc_disconnect();
			$query = sprintf ("insert into chanreg set channel_name='%s',
			   owner_handle='%s', owner_email='%s', owner_pass='%s',
			   status='OK', result='%s', timestamp=NULL, ip='%s'",
                               mysql_escape_string($channel_name), 
                               mysql_escape_string($channel_owner_handle), 
                               mysql_escape_string($channel_owner_email),
                               md5($channel_owner_password), 
                               mysql_escape_string($data[3]), 
                               $_SERVER['REMOTE_ADDR'] );
		        $res = db_query ($query);
			$tpl->set_file ('main', 'templates/regsuccess.html');
			$tpl->set_var ('owner_handle', $channel_owner_handle);
			$tpl->set_var ('channel_name', $channel_name);
                        $tpl->set_var ('channel_owner_password', $channel_owner_password);
			include ("lang/en.php");
			$tpl->pparse ('out', 'main');
                        mail($channel_owner_email, "AfterNET channel registration for $channel_name",
                                 "Just a reminder,\n".
                                 "The channel registration for $channel_name has been\n".
                                 "processed.\n\n".
                                 "X2 is now in your channel. You can login by doing:\n".
                                 "/msg x2 $channel_name login $channel_owner_handle $channel_owner_password\n\n ".
                                 "Once logged in, please change your password by doing:\n".
                                 "/msg x2 $channel_name pass $channel_owner_password yournewpassword\n\n".
                                 "For more help with using x2, do /msg x2 help\n".
                                 "Thanks,\n".
                                 "     AfterNET Support team\n".
                                 "",
                                 "From: support@afternet.org\nReply-To: support@afternet.org\n");

                        return(FALSE);
		}

		elseif ( preg_match ("/(Registration Aborted|Error\:)/", $data[3]) ) {
			$object->irc_disconnect();
			$query = sprintf ("insert into chanreg set channel_name='%s',
			   owner_handle='%s', owner_email='%s', owner_pass='%s',
			   status='ERR', result='%s', timestamp=NULL, ip='%s'",
                               mysql_escape_string($channel_name), 
                               mysql_escape_string($channel_owner_handle), 
                               mysql_escape_string($channel_owner_email),
                               md5($channel_owner_password), 
                               mysql_escape_string($data[3]), 
                               $_SERVER['REMOTE_ADDR'] );
		        $res = db_query ($query);
			$tpl->set_file ('main', 'templates/regfailed.html');
			$tpl->set_var ('owner_handle', $channel_owner_handle);
			$tpl->set_var ('channel_name', $channel_name);
			$tpl->set_var ('fail_reason', $data[3]);
			include ("lang/en.php");
			$tpl->pparse ('out', 'main');
                        return(FALSE);
		}
	}
        return(TRUE);
}

function irc_on_nicknameinuse ( $data, $object )
{
	global $irc;
	$irc->irc_nick = "{$irc->irc_nick}_";
	$irc->irc_send_msg (sprintf ("NICK %s", $irc->irc_nick));
        return(TRUE);
}

function irc_on_timeout($data, $object)
{
    echo "Sorry, the registration process timed out. Please try again later.";
    return(FALSE);
}

function do_login_first()
{
    global $tpl, $channel_name, $channel_owner_handle,
            $channel_owner_email, $channel_owner_password,
            $irc, $irc_nick, $irc_user, $irc_name, $irc_host,
            $irc_server, $irc_botnick, $dbx, $db_server,
            $db_port, $db_user, $db_pass, $db_database,
            $db_table;

    $tpl->set_file ('main', 'templates/must_login.html');
    include ("lang/en.php");
    $tpl->pparse ('out', 'main');
}

function do_show_too_many($reason)
{
    global $tpl, $channel_name, $channel_owner_handle,
            $channel_owner_email, $channel_owner_password,
            $irc, $irc_nick, $irc_user, $irc_name, $irc_host,
            $irc_server, $irc_botnick, $dbx, $db_server,
            $db_port, $db_user, $db_pass, $db_database,
            $db_table;

    $tpl->set_file ('main', 'templates/too_many.html');
    $tpl->set_var ('Error', $reason);
    include("lang/en.php");
    $tpl->pparse('out', 'main');
}


function rate_limit()
{
    global $my;
    global $tpl, $channel_name, $channel_owner_handle,
            $channel_owner_email, $channel_owner_password,
            $irc, $irc_nick, $irc_user, $irc_name, $irc_host,
            $irc_server, $irc_botnick, $dbx, $db_server,
            $db_port, $db_user, $db_pass, $db_database,
            $db_table;

    /* 1 channel per day check */
    $yesterday = time() - (24 * 60 * 60);
    $strSQL = "
        select count(channel_name) 
         FROM  chanreg 
        WHERE  owner_handle='$my->username' 
           AND status='OK'
           AND unix_timestamp(timestamp) > $yesterday
    ";
    $res = db_query($strSQL);
    if(mysql_result($res, 0) > 0)
    {
        return("You may register only one channel per day");
    }

    /* 3 channels per month check */
    $lastmonth = time() - (24 * 60 * 60 * 30);
    $strSQL = "
        SELECT count(channel_name)
          FROM chanreg
          WHERE owner_handle='$my->username'
            AND status='OK'
            AND unix_timestamp(timestamp) > $lastmonth
    ";
    $res = db_query($strSQL);
    if(mysql_result($res, 0) >= 3)
    {
        return("You may register only one channel per month");
    }

    /* max 100 channels per day for all users */
    $yesterday = time() - (24 * 60 * 60);
    $strSQL = "
        select count(channel_name) 
         FROM  chanreg 
        WHERE  status='OK'
           AND unix_timestamp(timestamp) > $yesterday
    ";
    $res = db_query($strSQL);
    if(mysql_result($res, 0) > 50)
    {
        return("Our registration system is currently overloaded. Please check back tomorrow.");
    }
    /* max 3 channels per day for same IP address */
    $yesterday = time() - (24 * 60 * 60);
    $strSQL = "
        select count(channel_name) 
         FROM  chanreg 
        WHERE  status='OK'
           AND unix_timestamp(timestamp) > $yesterday
           AND ip='$_SERVER[REMOTE_ADDR]'
    ";
    $res = db_query($strSQL);
    if(mysql_result($res, 0) >= 3)
    {
        return("Too many registrations from your IP. Please contact us.");
    }
    return FALSE;
}

$dbx = db_connect();
$tpl = new Template();
$irc = new IRCClient ($irc_nick, $irc_user, $irc_name, $irc_host);

if(!$my->id)
{
    do_login_first();
}
else
{
    switch ($_REQUEST['step'])
    {
         default:
        case '1':
                do_step_one();
                break;
                
        case '2':
                $reason = rate_limit();
                if($reason)
                    do_show_too_many($reason);
                else
                    do_step_two();
                break;
    }
}
?>
